<?php
/*
Plugin Name: PingAutomatic
Plugin URI: http://pingautomatic.com/
Description: PingAutomatic is a Wordpress plugin developed by Empire Marketing, Canada. With PingAutomatic you can keep your site pages indexed faster by leading Search Engines and improve your Site's Search Engine Ranking
Version: 1.0
Author: Krish MK
Author URI: http://empiremarketing.ca/
*/

/*
All functions are named with the prefix "Emp_pingauto" - Empire Marketing's PingAutomatic
*/

global $wpdb;

 /*
PINGAUTOMATIC CONSTANTS
*/

if (!defined('PINGAUTO_VERSION')) {
  define('PINGAUTO_VERSION', "1.0");  
}

if (!defined('PINGAUTO_DIR')) {
	define('PINGAUTO_DIR', WP_PLUGIN_DIR . '/' . "pingautomatic-plugin/");
	}
	
if (!defined('PINGAUTO_BACKLINKS_TBL')) {
  define('PINGAUTO_BACKLINKS_TBL', $wpdb->prefix . "pingauto_backlinks");  
}	

if (!defined('PINGAUTO_CAMPAIGNS_TBL')) {
  define('PINGAUTO_CAMPAIGNS_TBL', $wpdb->prefix . "pingauto_campaigns");  
}

if (!defined('PINGAUTO_IGNORE_IP_TBL')) {
  define('PINGAUTO_IGNORE_IP_TBL', $wpdb->prefix . "pingauto_ignore_ip");  
}

if (!defined('PINGAUTO_IGNORE_URLS_TBL')) {
  define('PINGAUTO_IGNORE_URLS_TBL', $wpdb->prefix . "pingauto_ignore_urls");  
}

if (!defined('PINGAUTO_RSS_DESC_TBL')) {
  define('PINGAUTO_RSS_DESC_TBL', $wpdb->prefix . "pingauto_rss_desc");  
}

if (!defined('PINGAUTO_STATS_TBL')) {
  define('PINGAUTO_STATS_TBL', $wpdb->prefix . "pingauto_stats");  
}

if (!defined('PINGAUTO_TITLES_TBL')) {
  define('PINGAUTO_TITLES_TBL', $wpdb->prefix . "pingauto_titles");  
}

if (!defined('PINGAUTO_URLS_TBL')) {
  define('PINGAUTO_URLS_TBL', $wpdb->prefix . "pingauto_urls");  
}

if (!defined('PINGAUTO_LOG_IP_TBL')) {
  define('PINGAUTO_LOG_IP_TBL', $wpdb->prefix . "pingauto_log_ip");  
}
	

/*
This is required to display the css/scripts only for our plugin pages
$our_pages 
*/

$our_pages = array("pingautomatic-main", "pingautomatic-add-campaign", "pingautomatic-manage-campaigns", "pingautomatic-rss-desc");

/*
Create db tables required by PingAutomatic during Plugin activation by the Admin user
Queries are included from includes folder - install_tables.php and add_rss_desc.php
*/

if (!function_exists(Emp_pingauto_install)) {
    function Emp_pingauto_install() {
      require(PINGAUTO_DIR . "includes/install_tables.php");
      require_once(ABSPATH . "wp-admin/includes/upgrade.php");
      
      /* Using dbDelta function to perform create tables queries */
      dbDelta($query_array);  
      
      /* Description for RSS db table */
      require(PINGAUTO_DIR . "includes/add_rss_desc.php");
      
      /* Store PingAutomatic Version */
      add_option("pingauto_version", PINGAUTO_VERSION);
      }
    }
    
    
/* Remove all data stored by PingAutomatic during plugin deactivation */

if (!function_exists(Emp_pingauto_uninstall)) {
    function Emp_pingauto_uninstall() {
     global $wpdb; 
     
     $query = "DROP TABLE " . PINGAUTO_BACKLINKS_TBL . ", " . PINGAUTO_CAMPAIGNS_TBL . ", " . PINGAUTO_IGNORE_IP_TBL . ", " . PINGAUTO_IGNORE_URLS_TBL . ", " . PINGAUTO_RSS_DESC_TBL . ", " . PINGAUTO_STATS_TBL . ", " . PINGAUTO_TITLES_TBL . ", " . PINGAUTO_URLS_TBL . "," . PINGAUTO_LOG_IP_TBL; 
      
     $remove_tables = $wpdb->query($query);   
    
     /* Remove PingAutomatic Version stored in wp options */
     delete_option("pingauto_version");
      }
    }
    
/* Admin Main Menu */
if (!function_exists(Emp_pingauto_menu)) {
    function Emp_pingauto_menu() {
     add_menu_page("PingAutomatic Main Screen", "PingAutomatic", "administrator", "pingautomatic-main", 'Emp_pingauto_show_default', WP_PLUGIN_URL . "/pingautomatic-plugin/images/favicon.ico");
      }
    }    
    
/* Main Page for PingAutomatic */
if (!function_exists(Emp_pingauto_show_default)) {
    function Emp_pingauto_show_default() {
      require(PINGAUTO_DIR . "includes/main.php");
      }
    }
    
if (!function_exists(Emp_pingauto_submenu)) {
    function Emp_pingauto_submenu() {
     add_submenu_page("pingautomatic-main", "Add Campaign", "Add Campaign", "administrator", "pingautomatic-add-campaign", 'Emp_pingauto_add_camp');
     add_submenu_page("pingautomatic-main", "Manage Campaigns", "Manage Campaigns", "administrator", "pingautomatic-manage-campaigns", 'Emp_pingauto_manage_camp');
     add_submenu_page("pingautomatic-main", "RSS Descriptions", "RSS Setting", "administrator", "pingautomatic-rss-desc", 'Emp_pingauto_rss_desc');
      }
    }        

/* Add Campaign Page */

if (!function_exists(Emp_pingauto_add_camp)) {
    function Emp_pingauto_add_camp() {
      require(PINGAUTO_DIR . "includes/add_campaign.php");
      }
    }
    
/* Add Manage Campaigns Page */

if (!function_exists(Emp_pingauto_manage_camp)) {
    function Emp_pingauto_manage_camp() {
      require(PINGAUTO_DIR . "includes/manage_campaigns.php");
      }
    }
    
/* Add RSS Descriptions Page */
if (!function_exists(Emp_pingauto_rss_desc)) {
    function Emp_pingauto_rss_desc() {
      require(PINGAUTO_DIR . "includes/rss_desc.php");
      }
    }        
        

/* Enqueue Style and Script Files */

if (!function_exists(Emp_pingauto_add_styles)) {
    function Emp_pingauto_add_styles() {
      global $our_pages;
      
      if (!in_array($_GET['page'], $our_pages)) {
      return;
      }
      else {
        $style_handle = "pingauto-css";
        $style_src = WP_PLUGIN_URL . "/pingautomatic-plugin/css/default.css";
        wp_register_style($style_handle, $style_src);
        wp_enqueue_style($style_handle);
        }
      }
    }
    
if (!function_exists(Emp_pingauto_add_scripts)) {
    function Emp_pingauto_add_scripts() {
      global $our_pages;
      
      if (!in_array($_GET['page'], $our_pages)) {
      return;
      }
      
      else {
        $script_handle = "pingauto-script";
        $script_src = WP_PLUGIN_URL . "/pingautomatic-plugin/js/main.js";
        wp_register_script($script_handle, $script_src);
        wp_enqueue_script($script_handle);
      }
      }
    }

/* Custom RSS feed for PingAutomatic */

if (!function_exists(Emp_pingauto_outputXMLFeed)) {    
  function Emp_pingauto_outputXMLFeed() {
  require(PINGAUTO_DIR . "functions/generate_rss.php");
  }
}


if (!function_exists(Emp_pingauto_feed)) {    
  function Emp_pingauto_feed() {
  add_feed("pingautomatic-rss", 'Emp_pingauto_outputXMLFeed');
  }
}

/* Generate Pings in footer area */

if (!function_exists(Emp_pingauto_pings)) {    
  function Emp_pingauto_pings() {
  if (is_single() || is_page() || is_home()) {
    require(PINGAUTO_DIR . "functions/generate_pings.php");
  }
  }
}

        

/*
First set up custom tables required for Pingautomatic during Plugin Installation
*/
register_activation_hook(__FILE__, 'Emp_pingauto_install');

register_deactivation_hook(__FILE__, 'Emp_pingauto_uninstall');

/*
Hook for adding Admin menus
*/
add_action('admin_menu', 'Emp_pingauto_menu');

add_action('admin_menu', 'Emp_pingauto_submenu');


/* Hook for including Stylesheet and Javascript File */

add_action('admin_print_styles', 'Emp_pingauto_add_styles');

add_action('admin_enqueue_scripts', 'Emp_pingauto_add_scripts');


/* RSS feed for PingAutomatic */
add_action('init', 'Emp_pingauto_feed');


/* PingAutomatic Core function: Generate Pings in footer area */

add_action ('wp_footer', 'Emp_pingauto_pings');

?>