<?php
# Grab POST variables
$campaign_name = trim($_POST['name']);
$campaign_title = trim($_POST['title']);
$campaign_pref = $_POST['ping_pref'];
$ping_pref = $campaign_pref;
$campaign_custom_urls = trim($_POST['custom_urls']);
$campaign_rss_url = trim($_POST['rss_url']);
$campaign_bk_urls = trim($_POST['bk_urls']);
$campaign_ip_addr = trim($_POST['ip_addr']);
$campaign_ref_sites = trim($_POST['ref_sites']);

# Start Validation
if (strlen($campaign_name) < 3 || strlen($campaign_name) > 50)
{
$err_msg[] = "Campaign Name is required (min. 3 characters/ maximum 50 characters)";
$err_count++;
}

if (strlen($campaign_title) < 6)
{
$err_msg[] = "Plz enter atleast one Keyword (min. 6 characters)";
$err_count++;
}

$pref_array = array("self", "custom");
if (!in_array($campaign_pref, $pref_array))
{
$err_msg[] = "Plz. select a valid Pinging Preference";
$err_count++;
}


# Now validate optional fields
if (strlen($campaign_rss_url) > 2083)
{
$err_msg[] = "RSS URL needs to be less than 2083 characters";
$err_count++;
}

if ($campaign_pref == "custom")
{
if (strlen($campaign_custom_urls) < 12)
{
$err_msg[] = "Plz enter atleast one url for custom pinging";
$err_count++;
}

else
{
# Form array of individual Custom URLs
$exp_campaign_custom_urls = array();
$exp_campaign_custom_urls = explode("\n", $campaign_custom_urls);

# Max. character check for each Custom URL
foreach ($exp_campaign_custom_urls as $check_custom_urls)
{
$check_custom_urls = trim($check_custom_urls);
if (strlen($check_custom_urls) > 2083)
{
$err_msg[] = "Custom URL - $check_custom_urls is greater than the allowed 2083 characters";
$err_count++;
}

if (strlen($check_custom_urls) < 12 && !empty($check_custom_urls))
{
$err_msg[] = "Custom URL - $check_custom_urls is less than the required minimum number of 12 characters";
$err_count++;
}
}

}
}

if (!empty($campaign_bk_urls))
{
# Form array of individual Backlinks URLs
$exp_campaign_bk_urls = array();
$exp_campaign_bk_urls = explode("\n", $campaign_bk_urls);

# Max. character check for each Backlink URL
foreach ($exp_campaign_bk_urls as $check_bk_urls)
{
$check_bk_urls = trim($check_bk_urls);
if (strlen($check_bk_urls) > 2083)
{
$err_msg[] = "Backlinks URL - $check_bk_urls is greater than the allowed 2083 characters";
$err_count++;
}
if (strlen($check_bk_urls) < 12 && !empty($check_bk_urls))
{
$err_msg[] = "Backlinks URL - $check_bk_urls is less than the required minimum number of 12 characters";
$err_count++;
}
}
}

if (!empty($campaign_ip_addr))
{
if (strlen($campaign_ip_addr) < 7)
{
$err_msg[] = "Invalid IP Address (Valid IP address is alteast 7 characters)";
$err_count++;
}
else
{
# Form array of individual Backlinks URLs
$exp_campaign_ip_addr = array();
$exp_campaign_ip_addr = explode("\n", $campaign_ip_addr);

# Max. character check for each IP Address
foreach ($exp_campaign_ip_addr as $check_ip_addr)
{
$check_ip_addr = trim($check_ip_addr);
if (strlen($check_ip_addr) > 15)
{
$err_msg[] = "IP Address - $check_ip_addr is invalid (greater than 15 characters)";
$err_count++;
}

if (strlen($check_ip_addr) < 7 && !empty($check_ip_addr))
{
$err_msg[] = "IP Address - $check_ip_addr is invalid (less than 7 characters)";
$err_count++;
}
}
}
}

if (!empty($campaign_ref_sites))
{
# Form array of individual Referring URLs
$exp_campaign_ref_sites = array();
$exp_campaign_ref_sites = explode("\n", $campaign_ref_sites);

# Max. character check for each Referring Site
foreach ($exp_campaign_ref_sites as $check_ref_sites)
{
$check_ref_sites = trim($check_ref_sites);
if (strlen($check_ref_sites) > 2083)
{
$err_msg[] = "Referring Sites URL - $check_ref_sites is greater than the allowed 2083 characters";
$err_count++;
}
if (strlen($check_ref_sites) < 5 && !empty($check_ref_sites))
{
$err_msg[] = "Referring Sites URL - $check_ref_sites is less than the required minimum number of 5 characters";
$err_count++;
}
}
}


# Form array of individual Titles
$exp_campaign_title = array();
$exp_campaign_title = explode("\n", $campaign_title);

# Max. character check for each Title
foreach ($exp_campaign_title as $check_title)
{
$check_title = trim($check_title);
if (strlen($check_ref_sites) > 500)
{
$err_msg[] = "Keyword - $check_title is greater than the allowed 500 characters";
$err_count++;
}
}





if ($err_count > 0)
{
echo ("<div id='error'>
<h3>Oops! $err_count error(s) found</h3>
<ol>");
foreach ($err_msg as $err_disp)
{
echo ("<li>$err_disp</li>");
}
echo ("</ol></div>");
}
else
{
# Add campaign Details
# Create Unique ID
$enc_id = md5(microtime());
$enc_time = time();


# Sanitize data for DB Storage
$enc_name = strip_tags(addslashes($campaign_name));
$enc_rss_url = strip_tags(addslashes($campaign_rss_url));

# Ping Preference conversion to TINYINT
if ($ping_pref == "self")
{
$ping_pref_code = "0";
}
else
{
$ping_pref_code = "1";
}

# INSERT INTO Campaigns table
$insert_campaign = "INSERT INTO campaigns (id, enc_id, name, ping_pref, rss_url, time, status) VALUES (NULL, '$enc_id', '$enc_name', '$ping_pref_code', '$enc_rss_url', '$enc_time', '1')";
$insert_campaign_res = mysql_query($insert_campaign, $con) or die(mysql_error());

$campaign_id = mysql_insert_id();

# Now INSERT Campaign title(s)
foreach ($exp_campaign_title as $check_title)
{
$enc_title = strip_tags(addslashes($check_title));
if (!empty($enc_title))
{
$insert_title = "INSERT INTO titles (id, title) VALUES('$campaign_id', '$enc_title')";
$insert_res = mysql_query($insert_title, $con) or die(mysql_error());
}
}

if ($ping_pref == "custom")
{
# INSERT custom URLS into urls table
foreach ($exp_campaign_custom_urls as $check_custom_url)
{
$enc_custom_url = strip_tags(addslashes($check_custom_url));
if (!empty($enc_custom_url))
{
$insert_url = "INSERT INTO urls (id, url) VALUES('$campaign_id', '$enc_custom_url')";
$insert_url_res = mysql_query($insert_url, $con) or die(mysql_error());
} 
}
}


if (!empty($campaign_bk_urls))
{
# INSERT backlinks into backlinks table
foreach ($exp_campaign_bk_urls as $check_bk_url)
{
$enc_bk_url = strip_tags(addslashes($check_bk_url));
if (!empty($enc_bk_url))
{
$insert_bk_url = "INSERT INTO backlinks (id, url) VALUES('$campaign_id', '$enc_bk_url')";
$insert_bk_url_res = mysql_query($insert_bk_url, $con) or die(mysql_error());
}
}
}


if (!empty($campaign_ip_addr))
{
foreach ($exp_campaign_ip_addr as $check_ip_addr)
{
$enc_ip_addr = trim(strip_tags(addslashes($check_ip_addr)));
if (!empty($enc_ip_addr))
{
$insert_ip_addr = "INSERT INTO `ignore_ip` (id, addr) VALUES('$campaign_id', INET_ATON('$enc_ip_addr'))";
$insert_ip_addr_res = mysql_query($insert_ip_addr, $con) or die(mysql_error());
}
}
}

if (!empty($campaign_ref_sites))
{
foreach ($exp_campaign_ref_sites as $check_ref_site)
{
$enc_ref_site = strip_tags(addslashes($check_ref_site));
if (!empty($enc_ref_site))
{
$insert_ref_site = "INSERT INTO `ignore_urls` (id, url) VALUES('$campaign_id', '$enc_ref_site')";
$insert_ref_site_res = mysql_query($insert_ref_site, $con) or die(mysql_error());
}
}
}

# Campaign Code generator
if ($_SERVER['HTTPS'] == on)
{
$protocol = "https://";
}
else
{
$protocol = "http://";
}

$current_url = htmlspecialchars($protocol . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI']);
$display_url = str_replace("add_campaign", "serve", $current_url);
$display_url3 = str_replace("serve.php", "script/js_encode.js", $display_url);

if (!empty($campaign_bk_urls))
{
$display_url_rss = base64_encode(str_replace("add_campaign.php", "rss.php?id=$enc_id", $current_url));
}

echo ("
<div style='background-color:#C3D313; padding:10px; margin:10px 2px;'>
<h2>Campaign Created</h2>
<p>
This Ping campaign has been successfully created.</p>

<p>Please add any 1 of the following codes into your site's PHP/html file where you want the ping code to be implemented<br />
If you are installing this on a wordpress blog, it is recommended that you  install this in your theme footer (just before the &lt;/body&gt; tag.  To get there, log in to your wp-admin area, click on \"appearance\", then \"editor\" and select the \"footer\").</p>

<h3>Option 1</h3>

<p class='highlight_notes'>PHP Code  - works on cURL enabled servers.<br />
Place the following code anywhere between the &lt;body&gt; &lt;/body&gt; tags</p>

<form>
<textarea name=\"code1\" rows=\"15\" cols=\"75\"><?php
\$ping_ref = base64_encode(\$_SERVER[HTTP_REFERER]);
\$ping_ip = \$_SERVER[REMOTE_ADDR];
\$ping_id = \"$enc_id\";
if (\$_SERVER[HTTPS] == on)
{
\$protocol = \"https://\";
}
else
{
\$protocol = \"http://\";
}
\$current_page = base64_encode(\$protocol . \$_SERVER[SERVER_NAME] . \$_SERVER[REQUEST_URI]);
\$ping_query = \"$display_url\" . \"?\" . \"id=\$ping_id&ip=\$ping_ip&ref=\$ping_ref&page=\$current_page&rss=$display_url_rss\";
\$ch = curl_init();
curl_setopt (\$ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt(\$ch, CURLOPT_URL, \"\$ping_query\");
\$ping_results = curl_exec(\$ch);
echo (\"\$ping_results\");
?></textarea>
</form>


<h3>Option 2</h3>

<p class='highlight_notes'>PHP Code -  requires remote URL access (allow_url_fopen() must be set to \"ON\")<br />
Place the following code anywhere between the &lt;body&gt; &lt;/body&gt; tags</p>

<form>
<textarea name=\"code2\" rows=\"15\" cols=\"75\"><?php
\$ping_ref = base64_encode(\$_SERVER[HTTP_REFERER]);
\$ping_ip = \$_SERVER[REMOTE_ADDR];
\$ping_id = \"$enc_id\";
if (\$_SERVER[HTTPS] == on)
{
\$protocol = \"https://\";
}
else
{
\$protocol = \"http://\";
}
\$current_page = base64_encode(\$protocol . \$_SERVER[SERVER_NAME] . \$_SERVER[REQUEST_URI]);
\$ping_query = \"$display_url\" . \"?\" . \"id=\$ping_id&ip=\$ping_ip&ref=\$ping_ref&page=\$current_page&rss=$display_url_rss\";
\$ping_results = file_get_contents(\$ping_query);
echo (\"\$ping_results\");
?></textarea>
</form>

<h3>Option 3 (follow both the steps)</h3>

<p class='highlight_notes'>Javascript Code - works on html files (may not work if your site's visitors browse thru a non-javascript/ javascript disabled browser)</p>

<h4>Step 1 </h4>
<p class='highlight_notes'><em>Place the following code anywhere between &lt;head&gt;&lt;/head&gt; tags</em></p>
<form>
<textarea name=\"code3\" rows=\"15\" cols=\"75\">
&lt;script src=\"http://ajax.microsoft.com/ajax/jquery/jquery-1.5.1.min.js\"&gt;&lt;/script&gt; 
&lt;script type=\"text/javascript\" src=\"$display_url3\"&gt;&lt;/script&gt; 
&lt;script type=\"text/javascript\"&gt; 
<!--
var ap_ref = base64_encode(document.referrer);
var ap_id = \"$enc_id\";
var ap_cp = base64_encode(document.URL);
var ap_ip = \"\";
$.getJSON(\"http://jsonip.appspot.com?callback=?\",function(jsonResult){
		ap_ip = jsonResult.ip;
var get_var = 'id='+ap_id+'&ref='+ap_ref+'&page='+ap_cp+'&ip='+ap_ip+'&rss=$display_url_rss';
$.get('$display_url', get_var, function(data) {
  $(\"#auto_pinger\").html(data);
});
}); 
//-->
&lt;/script&gt;</textarea>
</form>

<h4>Step 2</h4>
<p class='highlight_notes'><em>Place the following code anywhere between &lt;body&gt;&lt;/body&gt; tags</em></p>
<form>
<textarea name=\"code4\" rows=\"5\" cols=\"75\">
<div id=\"auto_pinger\"></div>
</textarea>
</form>



</div>
");


}
?>